function beat_result=beatconb(action,argv)
% For documentation see beatcon.m

Fsamp = 8000;   %- for playing sound through D/A and speakers, not plotting

if nargin<1,
   action='new';
end;

if nargin<2
   argv=1;
end;

if ~(strcmp(action,'new') | strcmp(action,'error_test'))
   info_block = get(gcf,'userdata');
end;

%------- NEW -----------------------------
if strcmp(action,'new'),
   
   % Preset Values Definitions
   dur=0.5;
   delf=50;
   amp_A=20;
   amp_B=0;
   fc=600;
   fs=8192;      %-Hz Starting Sampling Frequency FOR PLOTTING
   plo=0.01;
   
%   set_rate(8000);
   
    
   % -/- Initialize Main Panel  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-

   %initialize the control window 
   id_control_win = figure('units','normal','pos',[.38 .05 .6 .80],...%[.1 .1 .1 .1],...
                      'numbertitle','off','name','Beat Control Panel v2.4.1.j');
   %,'resize','off'
   
   %um_file     = uimenu('Label','<File...>');
   %um_load     = uimenu(um_file,'label','Load...');
   %um_save     = uimenu(um_file,'label','Save...','call','beatconb(''save'');');
   %um_info     = uimenu(um_file,'label','Info:');
   %              uimenu(um_info,'label','Beat Control Panel v2.4y  by Craig Ulmer with changes by Mark A. Yoder');
   %              uimenu(um_info,'label','- GRiMACE@ee.gatech.edu / Fall 1995 -');
   %              uimenu(um_info,'label',' ');
   %              uimenu(um_file,'label','Exit','call','beatconb(''exit'');');               
   %um_printops = uimenu('label','<Print Ops>');
   %um_toprinter= uimenu(um_printops,'label','To Printer','call','beatconb(''print'');');
   %um_toprinter= uimenu(um_printops,'label','To PS File','call','beatconb(''pr_ps'');');
   %um_toprinter= uimenu(um_printops,'label','To EPS File','call','beatconb(''pr_eps'');');

  
   %t0=clock;
   %while (1>etime(clock,t0))  %Delayfor redraw of menus
   %end; 
      
   %drawnow;
   
   
 
   uicontrol(gcf, 'style','frame','units','normal','pos',[0 0.94 1 0.06], 'back',[.4 .4 .4] );
   
   um_file=uicontrol('Max',0 ,'Min',1 ,'Units','norm','back',[.5 .5 .5],'fore',[1 1 1],... 
                     'Pos',[ 0.01 0.945 0.18 0.05 ],... 
                     'Style','popupmenu',... 
                     'string','<File...> |Load...|Save...|Exit');

   uicontrol('Max',0 ,'Min',1 ,'Units','norm','back',[.5 .5 .5],'fore',[1 1 1],...
                     'Call','beatconb(''ui_print'',gco);',... 
                     'Pos',[ 0.19 0.945 0.20 0.05 ],... 
                     'Style','popupmenu',... 
                     'string','<Print...> |To Printer |To PS File |To EPS File');


   plot_axes=axes('units','norm','pos',[0.07 0.50 0.90 0.40]); 
   
   
   % -/- Define Frames -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-

   beatconb('gen_frame',str2mat('Frequency Controls','0.005','0.21','0.33','0.20') );
   beatconb('gen_frame',str2mat(' ',                 '0.005','0.01','0.33','0.10') );
   beatconb('gen_frame',str2mat(' ',                 '0.005','0.11','0.33','0.10') ); 
   beatconb('gen_frame',str2mat('Amplitude Controls','0.335','0.21','0.33','0.20') );
   beatconb('gen_frame',str2mat('Plot Controls',     '0.335','0.01','0.33','0.20') );
   beatconb('gen_frame',str2mat('Graph Options',     '0.665','0.01','0.33','0.20') );
   beatconb('gen_frame',str2mat(' ',                 '0.665','0.21','0.33','0.20') );
          
   % -/- Define the Edit/Slider Combos -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-

   id_fc  =beatconb('gen_combo',str2mat('Fc(Hz):',      '0.005','0.30','0.33','100',   '1000', num2str(fc),   '5'));
   id_delf=beatconb('gen_combo',str2mat('Delf(Hz):',    '0.005','0.22','0.33','-100',  '100',  num2str(delf), '2'));
   id_dur =beatconb('gen_combo',str2mat('Duration(s):', '0.005','0.13','0.33','0.1',     '5',  num2str(dur),  '1'));
   id_ampa=beatconb('gen_combo',str2mat('Amplitude A:', '0.335','0.30','0.33','-20',   '+20',  num2str(amp_A),'3'));
   id_ampb=beatconb('gen_combo',str2mat('Amplitude B:', '0.335','0.22','0.33','-20',   '+20',  num2str(amp_B),'4'));
   id_plo =beatconb('gen_combo',str2mat('Plot Time(s):','0.335','0.02','0.33','.001',  '2',    num2str(plo),  '7'));
   id_fs  =beatconb('gen_combo',str2mat('Fs(Hz):',      '0.335','0.10','0.33','100',   '20000',num2str(fs),   '6'));
          
% -/- Use External Button  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/

   cb_ext_beat = uicontrol('style','checkbox','units','normal', 'back',[.4 .4 .9],'fore',[1 1 1],...
                           'string','Use External ''beat()''', ...
                           'pos',[0.015 0.03 0.31 0.05],...
                           'val',0,... 
                           'call','beatconb(''ext_beat'',gco);');
                         
% -/- Play Current Button  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/

   uicontrol('style','push','units','normal', ...
                     'string','Play As Sound','pos',[0.675 0.32 0.31 0.07],...
                     'call','beatconb(''play_sound'');' );

% -/- Play Example Button   -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
% Plays a simple example

   uicontrol('style','push','units','normal', ...
                     'string','Play An Example','pos',[0.675 0.23 0.31 0.07],...
                     'call','beatconb(''play_example'');' );

% -/- Plot Method Menu   -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/

 uicontrol('CallBack','beatconb(''change_plot_type'',get(gco,''val'') );',... 
                     'Max',0 ,'Min',1 ,'Units','norm','back',[.4 .4 .9],'fore',[1 1 1],... 
                     'Pos',[ 0.675 0.10 0.31 0.05 ],... 
                     'Style','popupmenu',... 
                     'string','Use plot() |Use stem()');

% -/- Set Grid CB  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/

   uicontrol('style','checkbox','units','normal','back',[.4 .4 .9],'fore',[1 1 1],... 
                           'string','Turn Grid On', ...
                           'pos',[0.675 0.03 0.31 0.05],...
                           'val',0,...
                           'call','beatconb(''grid_tog'',gco);');

% -/- Final Inits  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/- 

  file_call = ['argv=get(gco,''val'');',...
               'set(gco,''val'',1);',...
               'if argv==2, ',...
               '   beatconb(''load'',[',num2str(id_dur(1),32), ' ',num2str(id_dur(2),32) ,' ',...
                                         num2str(id_delf(1),32),' ',num2str(id_delf(2),32),' ',...
                                         num2str(id_ampa(1),32),' ',num2str(id_ampa(2),32),' ',...
                                         num2str(id_ampb(1),32),' ',num2str(id_ampb(2),32),' ',...
                                         num2str(id_fc(1),32),' '  ,num2str(id_fc(2),32)  ,' ',...
                                         num2str(id_fs(1),32),  ' ',num2str(id_fs(2),32)  ,' ',...
                                         num2str(id_plo(1),32), ' ',num2str(id_plo(2),32) ,']);',...
               'end;',...                          
               'if argv==3, ',...
               '  beatconb(''save'');end;',...
               'if argv==4, ',...
               '  beatconb(''exit'');end;',...
               'end;'];        

   set(um_file,'call',file_call)

  info_block=[ dur delf amp_A amp_B fc fs plo plot_axes 0 1 -1 0];
  set(gcf,'userdata',info_block);
  beatconb('update');
  drawnow;

    
% -/- Error Checking  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'error_test'),
 
  beat_result=0;  
  
  if (exist('beat')==2)
    
    fs=Fsamp;
    %churn out some test numbers so the lengths can be compared
    tttmp=0:1/fs:0.5;
    xxample = 30*cos(2*pi*(199.5)*tttmp)+40*cos(2*pi*(200.5)*tttmp);
    eval('yyample = beat(30,40,200,1,fs,0.5);');
    
    %check to see if the lengths of the output are the same
    if size(xxample,2)~=size(yyample)
     sprintf(['Beat.m gave the wrong length of output. Length(computed)=',...
       num2str(size(yyample,2)),' / Length (expected)=',num2str(size(xxample,2))])
       beat_result=1;   
    end,
  else
    sprintf('Did not find the ''beat.m'' file.'),
    beat_result=1;
  end;  

% -/- Gen Frame  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'gen_frame'),
%  
%
   text_height=0.03;
    
   our_pos=[str2num(argv(2,:)) str2num(argv(3,:)) str2num(argv(4,:)) str2num(argv(5,:))];
   
   % Set up a blank frame where specified
   uicontrol(gcf, 'style','frame','units','normal','pos', our_pos','back',[.4 .4 .7],'fore',[.4 .4 .8] );
   
   % Write up the text   
   uicontrol('style','text','units','normal','back',[.4 .4 .7],'fore',[1 1 1],...
          'pos', [(our_pos(1)+.05*our_pos(3)),...
                  (our_pos(2)+our_pos(4)-text_height -.5*text_height),... 
                  (.90*our_pos(3)), text_height ],...
          'horizontalalignment','center','string',argv(1,:));

% -/- Gen Slider/Edit combo  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'gen_combo'),
% Generates a Slider/Edit box combo based on the info passed 
%        

   ind_height=0.035;
   sli_height=0.02;
   ed_offset =0.10;
  
   loleft   =str2num(argv(2,:));
   lolo     =str2num(argv(3,:));
   frm_size =str2num(argv(4,:));
   val_min  =str2num(argv(5,:));
   val_max  =str2num(argv(6,:));
   val_start=str2num(argv(7,:));
   %--program_block index=argv(8,:)
   
   tot_length=.90*frm_size;
   loleft=loleft+.05*frm_size;
   ed_offset=.50*tot_length;
   
   % Slider
   slider_id = uicontrol(gcf,...
         'Style','slider','units','normal','back',[.4 .4 .9],'fore',[1 1 1],...
         'Min',val_min,'Max',val_max,'val',val_start,...
         'pos',[loleft lolo tot_length sli_height]);

   % Edit
   edit_id = uicontrol('style','edit','units','normal','horizontalalignment','left','back',[.4 .4 .9],'fore',[1 1 1],...
                 'pos', [(loleft+ed_offset) (lolo+sli_height) (tot_length-ed_offset) ind_height], ...
                 'string', argv(7,:), 'val', val_start);

   % Text
   uicontrol('style','text','units','normal','back',[.4 .4 .7],'fore',[1 1 1],...
          'pos', [loleft (lolo+sli_height) ed_offset ind_height], ...
          'horizontalalignment','left','string',argv(1,:) );
          
  % Set Callbacks for the Slider and Edit box
  set(slider_id,'call',['beatconb(''set_edsli'',[ get(gco,''value'') ',...
                         argv(5,:),' ',argv(6,:),' ',argv(8,:),' ',...
                         num2str(slider_id,32),' ',num2str(edit_id,32),' ]);']);
                         
  set(edit_id,'call',['beatconb(''set_edsli'',[ str2num(get(gco,''string'')) ',...
                         argv(5,:),' ',argv(6,:),' ',argv(8,:),' ',...
                         num2str(slider_id,32),' ',num2str(edit_id,32),' ]);']);
   
  beat_result=[slider_id edit_id];
  
% -/- Change Plot/Stem  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'change_plot_type'),
    
    info_block(10)=argv;
    set(gcf,'userdata',info_block);
    beatconb('update'); 

% -/- Toggle Grid  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'grid_tog'),
    
    info_block(12)=get(argv,'val');
    axes(info_block(8));
    if info_block(12)
       grid on;
    else
       grid off;
    end;      
    set(gcf,'userdata',info_block); 
   
% -/- Handle changes  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'set_edsli'),
% Generic range check for slider/edit combo. Checks to see if the change  
% is valid, then updates the relevant objects. Needs argv input as:
%    (1) new value  (2) range min (3) range max 
%    (4) Index of var in info_block 
%    (5) slider id  (6) edit id

  made_a_change=0;
  
  if ( (argv(2) <= argv(1) ) & (argv(1) <= argv(3)) )
     set_value=argv(1);
     info_block( argv(4) )=set_value;
     made_a_change=1;
  else
     set_value=info_block( argv(4) ); %-bad value-reset
  end;
     
  set( argv(5),'val',set_value);            %-sets slider
  set( argv(6),'string',sprintf('%8.3f',set_value) );%-sets edit  
  set( argv(6),'val',set_value );   

  set(gcf,'userdata',info_block);

  if made_a_change
       beatconb('update');
  end;
       
% -/- Gen new data and update  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'update'),
 
  axes(info_block(8));
  tt=0:1/info_block(6):info_block(7);
  if (info_block(9)==1)
    eval('xxtemp=beat(info_block(3),info_block(4),info_block(5),info_block(2),info_block(6),info_block(7));');
  else
    xxtemp = info_block(3)*cos(2*pi*(info_block(5)-info_block(2))*tt) + ...
             info_block(4)*cos(2*pi*(info_block(5)+info_block(2))*tt);
  end;
  if (info_block(10)==1)
      plot(tt,xxtemp(1:length(tt)));
  else
      stem(tt,xxtemp(1:length(tt)));
  end;    
  amp_max=1.25*(max(abs(xxtemp)))+.0001;
  axis([0 info_block(7) -amp_max amp_max]);
  if info_block(12)
     grid on;
  else
     grid off;
  end;      

  title('Sum of Cosines');
  xlabel('Time(s)');
  ylabel('Amplitude');
  
  beat_result=xxtemp;
  
% -/- Play Current  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'play_sound'),

  if info_block(9)==1
     eval('xxtemp=beat(info_block(3),info_block(4),info_block(5),info_block(2),Fsamp,info_block(1));');
  else
     tttmp=0:1/Fsamp:info_block(1);
     xxtemp = info_block(3)*cos(2*pi*(info_block(5)-info_block(2))*tttmp) + ...
              info_block(4)*cos(2*pi*(info_block(5)+info_block(2))*tttmp);
  end;
  sound( xxtemp/max(abs(xxtemp)), Fsamp );    %--jMc 20-Oct-1997

% -/- Play Example  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'play_example'),

  tttmp=0:1/Fsamp:2;
  xxtemp=20*sin(2*pi*499.2*tttmp)+17*sin(2*pi*500.8*tttmp);
  sound( xxtemp/max(abs(xxtemp)), Fsamp );    %--jMc 20-Oct-1997

% -/- External Beat Change -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'ext_beat'),
  
   
  if (~info_block(9) & ~beatconb('error_test') )
      set(argv,'val',1);
      info_block(9)=1;
  else
      set(argv,'val',0);
      info_block(9)=0;
  end;
  
  set(gcf,'userdata',info_block);
  
  beatconb('update');

% -/- Save Data -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'save'),

  global beat_duration beat_delf beat_amp_a beat_amp_b beat_fc beat_fs beat_plot_time beat_sample;
  
  beat_duration =info_block(1);
  beat_delf     =info_block(2);
  beat_amp_a    =info_block(3);           
  beat_amp_b    =info_block(4);
  beat_fc       =info_block(5);
  beat_fs       =info_block(6);
  beat_plot_time=info_block(7);
  tttmp=0:1/info_block(6):info_block(1);
  beat_sample=beat_amp_a*cos(2*pi*(beat_fs-beat_delf)*tttmp)+beat_amp_b*cos(2*pi*(beat_fs+beat_delf)*tttmp);

  [fn,pth] = uiputfile('*.mat','Save Plots');
  if fn
     eval(['save ',pth,fn,...
           ' beat_duration beat_delf beat_amp_a beat_amp_b beat_fc',...
           ' beat_fs beat_plot_time beat_sample' ]);
  end;
  
  clear beat_duration beat_delf beat_amp_a beat_amp_b beat_fc beat_fs beat_plot_time beat_sample;       
  
% -/- Load Data -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'load'),

  [fn,pth] = uigetfile('*.mat','Load Plot');

  if fn
    eval(['load ',pth,fn,';']);

    info_block(1)=beat_duration;
    set(argv(1),'val',beat_duration);
    set(argv(2),'string',num2str(beat_duration));
    info_block(2)=beat_delf;
    set(argv(3),'val',beat_delf);
    set(argv(4),'string',num2str(beat_delf));
    info_block(3)=beat_amp_a;           
    set(argv(5),'val',beat_amp_a);
    set(argv(6),'string',num2str(beat_amp_a));
    info_block(4)=beat_amp_b;
    set(argv(7),'val',beat_amp_b);
    set(argv(8),'string',num2str(beat_amp_b));
    info_block(5)=beat_fc;
    set(argv(9),'val',beat_fc);
    set(argv(10),'string',num2str(beat_fc));
    info_block(6)=beat_fs;
    set(argv(11),'val',beat_fs);
    set(argv(12),'string',num2str(beat_fs));
    info_block(7)=beat_plot_time;
    set(argv(13),'val',beat_plot_time);
    set(argv(14),'string',num2str(beat_plot_time));
    
    set(gcf,'userdata',info_block);
    beatconb('update');

  end;  

% -/- Print Window Gen -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'print_gen'),

  plot_data=beatconb('update');

  if ~any( get(0,'children') == info_block(11) );
      main_win=gcf;
      info_block(11)=figure('visible','off');
      set(main_win,'userdata',info_block);
  else
      figure(info_block(11));
  end;        
  
  num_samples=info_block(6)*info_block(7);
  tt=linspace(0,info_block(7),info_block(6)*info_block(7));

  if (info_block(10)==1)
      plot(tt,plot_data(1:length(tt)));
  else
      stem(tt,plot_data(1:length(tt)));
  end;    

  amp_max=1.25*(max(abs(plot_data)))+.0001;
  axis([0 info_block(7) -amp_max amp_max]);

  xlabel('Time');
  ylabel('Amplitude');
  
  username=getenv('USER');
  if ~isempty(username)
     username=[' by user ',username];
  end;
     
  title(['Beat Summation for Fc=',num2str(info_block(5)),...
         ', DelF=',num2str(info_block(2)),...
         ', A=',num2str(info_block(3)),...
         ', B=',num2str(info_block(4)),...
         ', Fs=',num2str(info_block(6)),username ]);
  
  beat_result=info_block(11);
    

% -/- Normal Print -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'print'),
   
   pr_id=beatconb('print_gen');
   figure(pr_id);
   eval('print ');
   set(pr_id,'visible','off');

% -/- Normal Print -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'pr_ps'),

  [fn,pth] = uiputfile('*.ps','Print PostScript');
  if fn
    pr_id=beatconb('print_gen');
    figure(pr_id);
    eval(['print -dps ',pth,fn,]);
    set(pr_id,'visible','off');
  end;
  
% -/- Normal Print -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'pr_eps'),

  [fn,pth] = uiputfile('*.eps','Print Encapsulated PostScript');
  if fn
    pr_id=beatconb('print_gen');
    figure(pr_id);
    eval(['print -deps ',pth,fn]);
    set(pr_id,'visible','off');
  end;
   
% -/- Exit -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'exit'),
  if any( get(0,'children') == info_block(11) );
      close(info_block(11));
  end;
  close(gcf);   
  
% -/- Change Print  -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-
elseif strcmp(action,'ui_print'),
   the_val=get(argv,'val');
   set(gco,'val',1);
   if the_val==2 
        beatconb('print');
   elseif the_val==3
        beatconb('pr_ps');
   elseif the_val==4
        beatconb('pr_eps');
   end;               
   
end;  

