function mypath = SPFirst
% Run this to update the MATLAB path to include the MATLAB demos.
%
%	Sinusoid Drill (sindrill)
%	Complex Number Drill (zdrill)
%   Phasor Races (phrace)
%   Fourier Series Demo (fseriesdemo)
%   Continuous to Discrete Sampling Demo (con2dis)
%   Continuous-Time Convolution Demo (cconvdemo)
%   Discrete-Time Convolution Demo (dconvdemo)
%   Continuous LTI Demo (cltidemo)
%   Discrete LTI Demo (dltidemo)
%	PEZ  Pole/Zero Plotter (pezdemo)
%	Music GUI (musiclab)
%	Beat Frequencies
% NOTE: this file must be on the MATLAB path

% Jim McClellan, 05-Dec

if strcmp(computer,'PCWIN')
    Sep='\';
elseif strcmp(computer,'MAC2')
    Sep=':';
else
    Sep='/';
end;

SP_path = which('spfirst');
if(strcmp(SP_path, ''))
    error('>> spfirst.m  must be in a directory already on your MATLAB path');
end

xx = findstr(SP_path, Sep);
xx = xx(length(xx));	% get last element of xx
SP_path = SP_path(1:xx-1);	% chop off dspfirst.m

ALL_dirs = {'sindrill', 'zdrill', 'fseriesdemo', 'phasorraces',...
            'cltidemo', 'dltidemo', 'cconvdemo', 'dconvdemo',...
		    'pezdemo', 'con2dis', 'musiclab' };
for kk = 1:length(ALL_dirs)
    if exist(ALL_dirs{kk},'dir')
        path(path,[SP_path, Sep, ALL_dirs{kk}]);
    end
end

mypath = path;
